unit FMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ColorGrd, StdCtrls, ExtCtrls, Spin, CheckLst, Demo1Settings;

type
  TfrmMain = class(TForm)
    butExit: TButton;
    panUser: TGroupBox;
    labUserName: TLabel;
    edUserName: TEdit;
    labUserAge: TLabel;
    edUserAge: TSpinEdit;
    grpEmployments: TGroupBox;
    rgrEmployment: TRadioGroup;
    lstEmployments: TCheckListBox;
    butOpenOther: TButton;
    procedure FormCreate(Sender: TObject);
    procedure edUserNameChange(Sender: TObject);
    procedure butExitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure butOpenOtherClick(Sender: TObject);
  private
    function GetEmployment: TEmployment;
    function GetEmployments: TEmployments;
    procedure SetEmployment(const Value: TEmployment);
    procedure SetEmployments(const Value: TEmployments);
  public
    property  Employment  : TEmployment   read GetEmployment  write SetEmployment;
    property  Employments : TEmployments  read GetEmployments write SetEmployments;
  end;

var
  frmMain: TfrmMain;

implementation

uses
  FOther;

{$R *.dfm}

{ TForm1 }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //  Apply form settings
  if  Settings.GUI.MainForm.Right > 0 then
    BoundsRect  := Settings.GUI.MainForm.BoundsRect;
  //  Apply user settings
  edUserName.Text := Settings.User.Name;
  edUserAge.Value := Settings.User.Age;
  Employment      := Settings.User.Employment;
  Employments     := Settings.User.Employments;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  //  Set settings
  Settings.GUI.MainForm.BoundsRect  := BoundsRect;
  Settings.User.Age         := edUserAge.Value;
  Settings.User.Employment  := Employment;
  Settings.User.Employments := Employments;
end;

procedure TfrmMain.edUserNameChange(Sender: TObject);
begin
  //  Set setting
  Settings.User.Name  := edUserName.Text;
end;

procedure TfrmMain.butOpenOtherClick(Sender: TObject);
begin
  frmOther.Show;
end;

procedure TfrmMain.butExitClick(Sender: TObject);
begin
  Close;
end;

//  Getter and setter methods for the properties Employment and Employments

function TfrmMain.GetEmployment: TEmployment;
begin
  Result  := TEmployment( rgrEmployment.ItemIndex )
end;

function TfrmMain.GetEmployments: TEmployments;
var
  e : TEmployment;
begin
  Result  := [];
  for e := Low(TEmployment) to High(TEmployment)  do
    if  lstEmployments.Checked[ integer(e) ]  then
      Result  := Result + [e]
end;

procedure TfrmMain.SetEmployment(const Value: TEmployment);
begin
  rgrEmployment.ItemIndex := integer( Value );
end;

procedure TfrmMain.SetEmployments(const Value: TEmployments);
var
  e : TEmployment;
begin
  for e := Low(TEmployment) to High(TEmployment)  do
    lstEmployments.Checked[ integer(e) ]  := e in Value
end;

end.
