unit FViewer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TfrmViewer = class(TForm)
    butClose: TButton;
    panItem: TGroupBox;
    panThings: TGroupBox;
    labName: TLabel;
    edName: TEdit;
    labNumber: TLabel;
    edNumber: TSpinEdit;
    labCount: TLabel;
    edCount: TSpinEdit;
    panColour: TPanel;
    butSelColour: TButton;
    ColorDialog: TColorDialog;
    procedure butCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure edNumberChange(Sender: TObject);
    procedure edNameChange(Sender: TObject);
    procedure edCountChange(Sender: TObject);
    procedure butSelColourClick(Sender: TObject);
  private
    procedure SettingsUpdate(Sender: TObject);
  public
    { Public declarations }
  end;

var
  frmViewer: TfrmViewer;

implementation

uses
  Demo6Settings;

{$R *.dfm}

{ TForm1 }

procedure TfrmViewer.butCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmViewer.FormCreate(Sender: TObject);
begin
  Settings.Things.OnChange.Subscribe( SettingsUpdate );
  Settings.Items.OnChange.Subscribe( SettingsUpdate );
  SettingsUpdate(nil);
end;

procedure TfrmViewer.FormDestroy(Sender: TObject);
begin
  Settings.Things.OnChange.Unsubscribe( SettingsUpdate );
  Settings.Items.OnChange.Unsubscribe( SettingsUpdate );
end;

procedure TfrmViewer.SettingsUpdate(Sender: TObject);
begin
  edName.Text     := Settings.Things.Name;
  edCount.Value   := Settings.Things.Count;
  edNumber.Value  := Settings.Items.Number;
  panColour.Color := Settings.Items.Colour;
end;

procedure TfrmViewer.edNumberChange(Sender: TObject);
begin
  Settings.Items.Number := edNumber.Value;
end;

procedure TfrmViewer.edNameChange(Sender: TObject);
begin
  Settings.Things.Name  := edName.Text;
end;

procedure TfrmViewer.edCountChange(Sender: TObject);
begin
  Settings.Things.Count := edCount.Value;
end;

procedure TfrmViewer.butSelColourClick(Sender: TObject);
begin
  if  ColorDialog.Execute then
    Settings.Items.Colour := ColorDialog.Color;
end;

end.
