unit FMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TfrmMain = class(TForm)
    panIntIndex: TGroupBox;
    lstIntIndex: TListBox;
    edIntIndex: TEdit;
    butAddIntIndex: TButton;
    butDelIntIndex: TButton;
    panEnumIndex: TGroupBox;
    grdEnumIndex: TStringGrid;
    butClose: TButton;
    procedure butAddIntIndexClick(Sender: TObject);
    procedure butDelIntIndexClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure butCloseClick(Sender: TObject);
    procedure grdEnumIndexSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    procedure ShowIntIndex;
    procedure ShowEnumIndex;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  Demo7Settings;

{ TForm3 }

procedure TfrmMain.butAddIntIndexClick(Sender: TObject);
begin
  Settings.IntIndex.Elems.Add( edIntIndex.Text );
  ShowIntIndex;
end;

procedure TfrmMain.butCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.butDelIntIndexClick(Sender: TObject);
begin
  if  lstIntIndex.ItemIndex >= 0  then
    Settings.IntIndex.Elems.Delete( lstIntIndex.ItemIndex );
  ShowIntIndex;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ShowIntIndex;
  ShowEnumIndex;
end;

procedure TfrmMain.grdEnumIndexSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  Settings.EnumIndex.Elems[ TEnum(ARow) ] := grdEnumIndex.Cells[1, ARow]
end;

procedure TfrmMain.ShowEnumIndex;
const
  EnumNames : array [TEnum] of string
            = ('eFirst', 'eSecond', 'eThird', 'eFourth');
var
  en : TEnum;
begin
  for en := Low(TEnum) to High(TEnum) do
    with  grdEnumIndex  do
      begin
        Cells[0, integer(en)] := EnumNames[en];
        Cells[1, integer(en)] := Settings.EnumIndex.Elems[ en ];
      end;
end;

procedure TfrmMain.ShowIntIndex;
begin
  lstIntIndex.Items.Assign( Settings.IntIndex.Elems );
end;

end.
