unit FIntIndex;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls, Grids, Demo8Settings;

type
  TfrmIntIndex = class(TForm)
    grpIntIndex: TGroupBox;
    butNew: TButton;
    butEdit: TButton;
    butDelete: TButton;
    butClose: TButton;
    labIntVal: TLabel;
    edIntVal: TSpinEdit;
    edStrVal: TEdit;
    labStrVal: TLabel;
    labGrdGroupName: TLabel;
    labGrdIntVal: TLabel;
    grdIntIndex: TStringGrid;
    labGrdStrVal: TLabel;
    procedure butNewClick(Sender: TObject);
    procedure butEditClick(Sender: TObject);
    procedure butDeleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure grdIntIndexSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    fSelectedElem : TElem;
  protected
    procedure ShowElems;
    property  SelectedElem  : TElem read fSelectedElem;
  public
    { Public declarations }
  end;

var
  frmIntIndex: TfrmIntIndex;

implementation

{$R *.dfm}

{ TfrmIntIndex }

procedure TfrmIntIndex.butDeleteClick(Sender: TObject);
begin
  Settings.IntIndex.DelElem( SelectedElem );
  ShowElems;
end;

procedure TfrmIntIndex.butEditClick(Sender: TObject);
begin
  with  SelectedElem  do
    begin
      IntVal  := edIntVal.Value;
      StrVal  := edStrVal.Text;
    end;
  ShowElems;
end;

procedure TfrmIntIndex.butNewClick(Sender: TObject);
begin
  with  Settings.IntIndex.AddElem do
    begin
      IntVal  := edIntVal.Value;
      StrVal  := edStrVal.Text;
    end;
  ShowElems;
end;

procedure TfrmIntIndex.FormCreate(Sender: TObject);
begin
  ShowElems;
end;

procedure TfrmIntIndex.grdIntIndexSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  fSelectedElem := Settings.IntIndex.GetElem( ARow );
  edIntVal.Value  := SelectedElem.IntVal;
  edStrVal.Text   := SelectedElem.StrVal;
end;

procedure TfrmIntIndex.ShowElems;
var
  Elem  : TElem;
  i : integer;
begin
  //  Empty the grid in case there is nothing to be shown
  grdIntIndex.Cells[0, 0]   := '';
  grdIntIndex.Cells[1, 0]   := '';
  grdIntIndex.Cells[2, 0]   := '';
  //  For each subgroup...
  grdIntIndex.RowCount  := Settings.IntIndex.Count;
  for i := 0 to Settings.IntIndex.Count-1 do
    begin
      Elem  := Settings.IntIndex.GetElem( i );
      //  ... fill in a row in the grid
      grdIntIndex.Objects[0, i] := Elem;
      grdIntIndex.Cells[0, i]   := Elem.GroupName;
      grdIntIndex.Cells[1, i]   := IntToStr( Elem.IntVal );
      grdIntIndex.Cells[2, i]   := Elem.StrVal;
    end;
end;

end.
